diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupSpecimenImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupSpecimenImport.java
index 5c11d49fc9..0e70274987 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupSpecimenImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupSpecimenImport.java
@@ -23,7 +23,6 @@ import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
-import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade.DerivedUnitType;
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacadeCacheStrategy;
 import eu.etaxonomy.cdm.common.CdmUtils;
 import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
@@ -34,18 +33,19 @@ import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.IndividualsAssociation;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaLevel;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
 import eu.etaxonomy.cdm.model.name.NonViralName;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignationStatus;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.occurrence.Collection;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
+import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;
 import eu.etaxonomy.cdm.strategy.exceptions.UnknownCdmTypeException;
 import eu.etaxonomy.cdm.strategy.parser.SpecimenTypeParser;
 import eu.etaxonomy.cdm.strategy.parser.SpecimenTypeParser.TypeInfo;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
 
 /**
  * @author a.mueller
@@ -122,7 +122,7 @@ public class MarkupSpecimenImport extends MarkupImportBase  {
 			firstName = CdmBase.deproxy(names.iterator().next(),NonViralName.class);
 		}
 
-		DerivedUnitFacade facade = DerivedUnitFacade.NewInstance(DerivedUnitType.Specimen);
+		DerivedUnitFacade facade = DerivedUnitFacade.NewInstance(SpecimenOrObservationType.PreservedSpecimen);
 		String text = "";
 		String collectionAndType = "";
 		// elements
@@ -188,9 +188,9 @@ public class MarkupSpecimenImport extends MarkupImportBase  {
 			Collection collection = createCollection(typeInfo.collectionString);
 
 			// TODO improve cache strategy handling
-			DerivedUnitBase typeSpecimen = facade.addDuplicate(collection, null, null, null, null);
+			DerivedUnit typeSpecimen = facade.addDuplicate(collection, null, null, null, null);
 			typeSpecimen.setCacheStrategy(new DerivedUnitFacadeCacheStrategy());
-			name.addSpecimenTypeDesignation((Specimen) typeSpecimen, typeStatus, null, null, null, false, addToAllNamesInGroup);
+			name.addSpecimenTypeDesignation(typeSpecimen, typeStatus, null, null, null, false, addToAllNamesInGroup);
 		}
 	}
 	
@@ -305,7 +305,7 @@ public class MarkupSpecimenImport extends MarkupImportBase  {
 				return result;
 			} else if (isStartingElement(next, FULL_DATE)) {
 				String fullDate = getCData(state, reader, next, true);
-				result = TimePeriod.parseString(fullDate);
+				result = TimePeriodParser.parseString(fullDate);
 				if (result.getFreeText() != null){
 					fireWarningEvent(String.format(parseMessage, FULL_DATE, fullDate), parent, 1);
 				}
@@ -445,14 +445,14 @@ public class MarkupSpecimenImport extends MarkupImportBase  {
 			} else if (isStartingElement(next, BR) || isEndingElement(next, BR)) {
 				//do nothing
 			} else if (isStartingElement(next, GATHERING)) {
-				DerivedUnitFacade facade = DerivedUnitFacade.NewInstance(DerivedUnitType.DerivedUnit.DerivedUnit);
+				DerivedUnitFacade facade = DerivedUnitFacade.NewInstance(SpecimenOrObservationType.DerivedUnit);
 				addCurrentAreas(state, next, facade);
 				handleGathering(state, reader, next, facade);
 				SpecimenOrObservationBase<?> specimen;
 				if (facade.innerDerivedUnit() != null){
 					specimen = facade.innerDerivedUnit();
 				}else{
-					specimen = facade.innerFieldObservation();
+					specimen = facade.innerFieldUnit();
 				}
 				IndividualsAssociation individualsAssociation = IndividualsAssociation.NewInstance();
 				individualsAssociation.setAssociatedSpecimenOrObservation(specimen);
@@ -479,7 +479,7 @@ private void addCurrentAreas(MarkupImportState state, XMLEvent event, DerivedUni
 		for (NamedArea area : state.getCurrentAreas()){
 			if (area == null){
 				continue;
-			}else if (area.isInstanceOf(WaterbodyOrCountry.class)){
+			}else if (area.isInstanceOf(Country.class)){
 				facade.setCountry(area);
 			}else{
 				String message = "Current area %s is not country. This is not expected for currently known data.";
@@ -529,11 +529,11 @@ private void addCurrentAreas(MarkupImportState state, XMLEvent event, DerivedUni
 				//gabon specific
 				if (text.contains("gabonais ")){
 					text = text.replace("gabonais ", "");
-					state.addCurrentArea(WaterbodyOrCountry.GABONGABONESEREPUBLIC());
+					state.addCurrentArea(Country.GABONGABONESEREPUBLIC());
 				}
 				if (text.contains(" pour le Gabon")){
 					text = text.replace(" pour le Gabon", "");
-					state.addCurrentArea(WaterbodyOrCountry.GABONGABONESEREPUBLIC());
+					state.addCurrentArea(Country.GABONGABONESEREPUBLIC());
 				}
 				
 				//update feature
@@ -562,12 +562,12 @@ private void addCurrentAreas(MarkupImportState state, XMLEvent event, DerivedUni
 
 
 	public String handleInLineGathering(MarkupImportState state, XMLEventReader reader, XMLEvent parentEvent) throws XMLStreamException {
-		DerivedUnitFacade facade = DerivedUnitFacade.NewInstance(DerivedUnitType.DerivedUnit.FieldObservation);
+		DerivedUnitFacade facade = DerivedUnitFacade.NewInstance(SpecimenOrObservationType.FieldUnit);
 		handleGathering(state, reader, parentEvent, facade);
-		SpecimenOrObservationBase<?> specimen  = facade.innerFieldObservation();
+		SpecimenOrObservationBase<?> specimen  = facade.innerFieldUnit();
 		if (specimen == null){
 			specimen = facade.innerDerivedUnit();
-			String message = "Inline gaterhing has no field observation";
+			String message = "Inline gaterhing has no field unit";
 			fireWarningEvent(message, parentEvent, 2);
 		}
 		
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupTransformer.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupTransformer.java
index df371e3e86..acdab071e8 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupTransformer.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupTransformer.java
@@ -15,6 +15,7 @@ import java.util.UUID;
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.io.common.TdwgAreaProvider;
 import eu.etaxonomy.cdm.io.common.mapping.InputTransformerBase;
 import eu.etaxonomy.cdm.io.common.mapping.UndefinedTransformerMethodException;
 import eu.etaxonomy.cdm.model.common.MarkerType;
@@ -24,7 +25,6 @@ import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
 import eu.etaxonomy.cdm.model.description.PresenceTerm;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaLevel;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
 
 /**
  * @author a.mueller
@@ -1304,26 +1304,26 @@ public class MarkupTransformer extends InputTransformerBase {
 	@Override
 	public NamedArea getNamedAreaByKey(String key) throws UndefinedTransformerMethodException {
 		if (CdmUtils.isBlank(key)){return null;
-		}else if (key.equalsIgnoreCase("Kalimantan")){return TdwgArea.getAreaByTdwgAbbreviation("BOR-KA");
-		}else if (key.equalsIgnoreCase("Borneo")){return TdwgArea.getAreaByTdwgAbbreviation("BOR");
-		}else if (key.equalsIgnoreCase("Peninsular Malaysia")){return TdwgArea.getAreaByTdwgAbbreviation("MLY-PM");
-			}else if (key.equalsIgnoreCase("Malay Peninsula")){return TdwgArea.getAreaByTdwgAbbreviation("MLY-PM");
-		}else if (key.equalsIgnoreCase("Java")){return TdwgArea.getAreaByTdwgAbbreviation("JAW-OO");
-		}else if (key.equalsIgnoreCase("Bismarck Archipelago")){return TdwgArea.getAreaByTdwgAbbreviation("BIS-OO");
-		}else if (key.equalsIgnoreCase("Sumatra")){return TdwgArea.getAreaByTdwgAbbreviation("SUM-OO");
-		}else if (key.equalsIgnoreCase("Sabah")){return TdwgArea.getAreaByTdwgAbbreviation("BOR-SB");
-			}else if (key.equalsIgnoreCase("North Borneo")){return TdwgArea.getAreaByTdwgAbbreviation("BOR-SB");
+		}else if (key.equalsIgnoreCase("Kalimantan")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("BOR-KA");
+		}else if (key.equalsIgnoreCase("Borneo")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("BOR");
+		}else if (key.equalsIgnoreCase("Peninsular Malaysia")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("MLY-PM");
+			}else if (key.equalsIgnoreCase("Malay Peninsula")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("MLY-PM");
+		}else if (key.equalsIgnoreCase("Java")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("JAW-OO");
+		}else if (key.equalsIgnoreCase("Bismarck Archipelago")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("BIS-OO");
+		}else if (key.equalsIgnoreCase("Sumatra")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("SUM-OO");
+		}else if (key.equalsIgnoreCase("Sabah")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("BOR-SB");
+			}else if (key.equalsIgnoreCase("North Borneo")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("BOR-SB");
 		
-		}else if (key.equalsIgnoreCase("Bali")){return TdwgArea.getAreaByTdwgAbbreviation("LSI-BA");
-		}else if (key.equalsIgnoreCase("Moluccas")){return TdwgArea.getAreaByTdwgAbbreviation("MOL-OO");
+		}else if (key.equalsIgnoreCase("Bali")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("LSI-BA");
+		}else if (key.equalsIgnoreCase("Moluccas")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("MOL-OO");
 		
-		}else if (key.equalsIgnoreCase("Indochina")){return TdwgArea.getAreaByTdwgAbbreviation("41");
-		}else if (key.equalsIgnoreCase("Lesser Sunda Islands")){return TdwgArea.getAreaByTdwgAbbreviation("LSI");
-		}else if (key.equalsIgnoreCase("Sulawesi")){return TdwgArea.getAreaByTdwgAbbreviation("SUL-OO");
-			}else if (key.equalsIgnoreCase("Celebes")){return TdwgArea.getAreaByTdwgAbbreviation("SUL-OO");
+		}else if (key.equalsIgnoreCase("Indochina")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("41");
+		}else if (key.equalsIgnoreCase("Lesser Sunda Islands")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("LSI");
+		}else if (key.equalsIgnoreCase("Sulawesi")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("SUL-OO");
+			}else if (key.equalsIgnoreCase("Celebes")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("SUL-OO");
 		
-		}else if (key.equalsIgnoreCase("south-east United States")){return TdwgArea.getAreaByTdwgAbbreviation("78");
-		}else if (key.equalsIgnoreCase("West Indies")){return TdwgArea.getAreaByTdwgAbbreviation("81");
+		}else if (key.equalsIgnoreCase("south-east United States")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("78");
+		}else if (key.equalsIgnoreCase("West Indies")){return TdwgAreaProvider.getAreaByTdwgAbbreviation("81");
 		
 		}else{
 			return null;
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputDocumentBuilder.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputDocumentBuilder.java
index 53dae092b1..7d122bc169 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputDocumentBuilder.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputDocumentBuilder.java
@@ -132,7 +132,7 @@ public class PilotOutputDocumentBuilder {
 					Feature feature = categorical.getFeature();
 					Representation representation = (Representation) feature.getRepresentations().toArray()[0];
 					texte += "<li>Categorical data associated with feature: <b>" + representation.getLabel() + "</b><br/>\nStates: ";
-					for (Iterator<? extends StateData> sd = categorical.getStates().iterator() ; sd.hasNext() ;){
+					for (Iterator<? extends StateData> sd = categorical.getStateData().iterator() ; sd.hasNext() ;){
 						StateData stateData = (StateData) sd.next();
 						texte += ((Representation) stateData.getState().getRepresentations().toArray()[0]).getLabel();
 						if (sd.hasNext()) texte += "; "; else texte += ".<br/>\n";
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputExporter.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputExporter.java
index 98ed573462..953ebd4981 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputExporter.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/pilotOutputHtml/PilotOutputExporter.java
@@ -39,7 +39,6 @@ import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 /**
  * @author h.fradin (from a.babadshanjan)
  * @created 10.12.2008
- * @versoin 1.0
  */
 @Component("pilotOutputExporter")
 public class PilotOutputExporter extends CdmExportBase<PilotOutputExportConfigurator, PilotOutputExportState, IExportTransformer> implements ICdmExport<PilotOutputExportConfigurator, PilotOutputExportState> {
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/ikeyplus/IkeyPlusImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/ikeyplus/IkeyPlusImport.java
index 250c71df9e..92a4fff465 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/ikeyplus/IkeyPlusImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/ikeyplus/IkeyPlusImport.java
@@ -22,6 +22,7 @@ import org.codehaus.plexus.util.StringUtils;
 import org.springframework.stereotype.Component;
 
 import eu.etaxonomy.cdm.io.common.CdmImportBase;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.KeyStatement;
@@ -50,7 +51,7 @@ public class IkeyPlusImport extends CdmImportBase<IkeyPlusImportConfigurator, Ik
 
     public static final Logger logger = Logger.getLogger(IkeyPlusImport.class);
 
-    private TermVocabulary<Feature> termVoc;
+    private TermVocabulary<Feature> featureVoc;
 
     private PolytomousKey cdmKey;
 
@@ -114,7 +115,7 @@ public class IkeyPlusImport extends CdmImportBase<IkeyPlusImportConfigurator, Ik
 
         cdmKey = PolytomousKey.NewTitledInstance(singleAccessKey.getLabel() + "_1");
 
-        termVoc = TermVocabulary.NewInstance(singleAccessKey.getLabel(), singleAccessKey.getLabel(), null, null);
+        featureVoc = TermVocabulary.NewInstance(TermType.Feature, singleAccessKey.getLabel(), singleAccessKey.getLabel(), null, null);
 
         Set<PolytomousKeyNode> rootNode = recursivlyCreateKeyNodes(singleAccessKey.getRoot(), null);
 //        Assert.assertEquals(1, rootNode.size());
@@ -135,7 +136,7 @@ public class IkeyPlusImport extends CdmImportBase<IkeyPlusImportConfigurator, Ik
         // persist features
         Collection features = featureMap.values();
         getTermService().saveOrUpdate(features);
-        getVocabularyService().saveOrUpdate(termVoc);
+        getVocabularyService().saveOrUpdate(featureVoc);
 
         // persist the rest
         getPolytomousKeyService().saveOrUpdate(cdmKey);
@@ -253,7 +254,7 @@ public class IkeyPlusImport extends CdmImportBase<IkeyPlusImportConfigurator, Ik
             String featureLabel = character.getName();
 
             Feature newFeature = Feature.NewInstance(featureLabel, featureLabel, null);
-            termVoc.addTerm(newFeature);
+            featureVoc.addTerm(newFeature);
             featureMap.put(character.getId(),
                     newFeature);
 
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/in/SDDDataSetImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/in/SDDDataSetImport.java
index 32256947ad..d8c08550cf 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/in/SDDDataSetImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/sdd/in/SDDDataSetImport.java
@@ -44,6 +44,7 @@ import eu.etaxonomy.cdm.model.agent.Team;
 import eu.etaxonomy.cdm.model.common.Annotation;
 import eu.etaxonomy.cdm.model.common.AnnotationType;
 import eu.etaxonomy.cdm.model.common.CdmBase;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.common.IdentifiableSource;
@@ -51,8 +52,10 @@ import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.LanguageString;
 import eu.etaxonomy.cdm.model.common.Marker;
 import eu.etaxonomy.cdm.model.common.MarkerType;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.common.Representation;
 import eu.etaxonomy.cdm.model.common.TermBase;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.common.VersionableEntity;
 import eu.etaxonomy.cdm.model.description.CategoricalData;
@@ -60,7 +63,6 @@ import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.FeatureNode;
 import eu.etaxonomy.cdm.model.description.FeatureTree;
 import eu.etaxonomy.cdm.model.description.MeasurementUnit;
-import eu.etaxonomy.cdm.model.description.Modifier;
 import eu.etaxonomy.cdm.model.description.QuantitativeData;
 import eu.etaxonomy.cdm.model.description.State;
 import eu.etaxonomy.cdm.model.description.StateData;
@@ -78,7 +80,7 @@ import eu.etaxonomy.cdm.model.media.MediaRepresentationPart;
 import eu.etaxonomy.cdm.model.media.Rights;
 import eu.etaxonomy.cdm.model.name.NonViralName;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
 import eu.etaxonomy.cdm.model.taxon.Classification;
@@ -115,8 +117,8 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 	private Map<String,MeasurementUnit> units = new HashMap<String,MeasurementUnit>();
 	private Map<String,TaxonNode> taxonNodes = new HashMap<String,TaxonNode>();
 	private Map<String,NamedArea> namedAreas = new HashMap<String,NamedArea>();
-	private Map<String,Specimen> specimens = new HashMap<String,Specimen>();
-	private Map<String,Modifier> modifiers = new HashMap<String,Modifier>();
+	private Map<String,DerivedUnit> specimens = new HashMap<String,DerivedUnit>();
+	private Map<String,DefinedTerm> modifiers = new HashMap<String,DefinedTerm>();
 	
 	private Set<MarkerType> markerTypes = new HashSet<MarkerType>();
 	private Set<TermVocabulary> vocabularies = new HashSet<TermVocabulary>();
@@ -162,25 +164,6 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 	public boolean doCheck(SDDImportState state){
 		boolean result = true;
 		makeIoClassList();
-
-//		for (Class<ICdmIO> ioClass: ioClassList){
-//			try {
-//				String ioBeanName = CdmApplicationAwareDefaultImport.getComponentBeanName(ioClass);
-//				ICdmIO cdmIo = (ICdmIO)getTermService().getBean(ioBeanName, ICdmIO.class);
-//				if (cdmIo != null){
-////					result &= cdmIo.invoke(config, stores);
-//					state.setCurrentIO(cdmIo);
-//					result &= cdmIo.invoke(state);
-//				}else{
-//					logger.error("cdmIO was null");
-//					result = false;
-//				}
-//			} catch (Exception e) {
-//					logger.error(e);
-//					e.printStackTrace();
-//					result = false;
-//			}
-//		}
 		logger.warn("No check implemented for SDD");
 		return result;
 	}
@@ -362,17 +345,17 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 	
 	/**
 	 * 
-	 * @param ve
+	 * @param media
 	 * @param langLabDet
 	 */
-	private void makeRepresentationForMedia(Media m, Map<Language, List<String>> langLabDet) {
+	private void makeRepresentationForMedia(Media media, Map<Language, List<String>> langLabDet) {
 		for (Language lang : langLabDet.keySet()){
 			List<String> labDet = langLabDet.get(lang);
 			if (labDet.get(0) != null){
-				m.putTitle(LanguageString.NewInstance(labDet.get(0), lang));
+				media.putTitle(LanguageString.NewInstance(labDet.get(0), lang));
 			}
 			if (labDet.size()>1) {
-				m.addDescription(labDet.get(1), lang);
+				media.putDescription(lang, labDet.get(1));
 			}
 		}
 	}
@@ -421,7 +404,8 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 					} else {
 						Reference<?> descriptionSource = ReferenceFactory.newGeneric();
 						sources.add(descriptionSource);
-						td.addSource(null, null, descriptionSource, null);
+						//TODO type
+						td.addSource(OriginalSourceType.Unknown, null, null, descriptionSource, null);
 						this.associateImageWithCdmBase(ref,descriptionSource);
 					}
 				} else {
@@ -637,7 +621,7 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 		for (String ref : taxonDescriptions.keySet()){
 			TaxonDescription td = taxonDescriptions.get(ref);
 			if (citations.containsKey(ref)) {
-				Reference publication = publications.get(citations.get(ref));
+				Reference<?> publication = publications.get(citations.get(ref));
 				if (locations.containsKey(ref)) {
 					Annotation location = Annotation.NewInstance(locations.get(ref), datasetLanguage);
 					AnnotationType annotationType = AnnotationType.NewInstance("", "location", "");
@@ -645,7 +629,8 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 					location.setAnnotationType(annotationType);
 					(publication).addAnnotation(location);
 				}
-				td.addSource(null, null, publication, null);
+				//TODO type
+				td.addSource(OriginalSourceType.Unknown, null, null, publication, null);
 			}
 		}
 		logger.info("end makeTaxonDescriptions ...");
@@ -674,7 +659,7 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 		for (Classification classification : classifications) {
 			getClassificationService().save(classification);
 		}
-		for (Specimen specimen : specimens.values()) {
+		for (DerivedUnit specimen : specimens.values()) {
 			getOccurrenceService().save(specimen);
 		}
 		logger.info("end of persistence ...");
@@ -736,7 +721,7 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 	}
 
 	private void saveModifiers() {
-		for (Modifier modifier : modifiers.values() ){
+		for (DefinedTerm modifier : modifiers.values() ){
 			getTermService().save(modifier);
 		}
 	}
@@ -779,9 +764,9 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 			int j = 0;
 			for (Element elSpecimen : listSpecimens) {
 				String id = elSpecimen.getAttributeValue("id");
-				Specimen specimen = null;
+				DerivedUnit specimen = null;
 				if (!id.equals("")) {
-					specimen = Specimen.NewInstance();
+					specimen = DerivedUnit.NewPreservedSpecimenInstance();
 					specimens.put(id,specimen);
 					importRepresentation(elSpecimen, sddNamespace, specimen, id, cdmState);
 				}
@@ -912,12 +897,11 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 				if (!id.equals("")) {
 					tnb = NonViralName.NewInstance(null);
 					IdentifiableSource source = null;
-					if (uri != null) {
-						if (!uri.equals("")) {
-							source = IdentifiableSource.NewInstance(id, "TaxonName", ReferenceFactory.newGeneric(), uri);
-						}
+					if (isNotBlank(uri)) {
+						//TODO type
+						source = IdentifiableSource.NewInstance(OriginalSourceType.Unknown, id, "TaxonName", ReferenceFactory.newGeneric(), uri);
 					} else {
-						source = IdentifiableSource.NewInstance(id, "TaxonName");
+						source = IdentifiableSource.NewDataImportInstance(id, "TaxonName");
 					}
 					tnb.addSource(source);
 					taxonNameBases.put(id,tnb);
@@ -977,7 +961,7 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 
 				// <StateDefinition id="s1">
 				List<Element> elStateDefinitions = elStates.getChildren("StateDefinition",sddNamespace);
-				TermVocabulary<State> termVocabularyState = TermVocabulary.NewInstance(null, null, null, null);
+				TermVocabulary<State> termVocabularyState = TermVocabulary.NewInstance(TermType.State, null, null, null, null);
 				
 				vocabularies.add(termVocabularyState);
 				
@@ -1216,9 +1200,9 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 	private Taxon handleCDNoScope(Namespace sddNamespace,
 			SDDImportState cdmState, Element elCodedDescription	) {
 		Taxon taxon = null;
-		NonViralName nonViralName = NonViralName.NewInstance(null);
+		NonViralName<?> nonViralName = NonViralName.NewInstance(null);
 		String id = new String("" + taxonNamesCount);
-		IdentifiableSource source = IdentifiableSource.NewInstance(id, "TaxonName");
+		IdentifiableSource source = IdentifiableSource.NewDataImportInstance( id, "TaxonName");
 		importRepresentation(elCodedDescription, sddNamespace, nonViralName, id, cdmState);
 		
 		if(cdmState.getConfig().isReuseExistingTaxaWhenPossible()){
@@ -1423,12 +1407,12 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 					List<Element> elModifiers = elState.getChildren("Modifier", sddNamespace);
 					for (Element elModifier : elModifiers){
 						ref = elModifier.getAttributeValue("ref");
-						Modifier modifier = modifiers.get(ref);
+						DefinedTerm modifier = modifiers.get(ref);
 						if (modifier != null) {
 							stateData.addModifier(modifier);
 						}
 					}
-					categoricalData.addState(stateData);
+					categoricalData.addStateData(stateData);
 				}
 				taxonDescription.addElement(categoricalData);
 			}
@@ -1457,7 +1441,7 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 					//  </Representation>
 					Person person = Person.NewInstance();
 					importRepresentation(elAgent, sddNamespace, person, idA, cdmState);
-					person.addSource(IdentifiableSource.NewInstance(idA, "Agent"));
+					person.addSource(IdentifiableSource.NewDataImportInstance(idA, "Agent"));
 
 					/*XIM <Links>
 					Element elLinks = elAgent.getChild("Links",sddNamespace);
@@ -1702,18 +1686,18 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 						Element elModifiers = elDescriptiveConcept.getChild("Modifiers", sddNamespace);
 					if (elModifiers !=null){
 						List<Element> listModifiers = elModifiers.getChildren("Modifier", sddNamespace);
-							TermVocabulary<Modifier> termVocabularyState = TermVocabulary.NewInstance(null, null, null, null);
+							TermVocabulary<DefinedTerm> termVocabularyState = TermVocabulary.NewInstance(TermType.Modifier, null, null, null, null);
 						for (Element elModifier : listModifiers) {
-								Modifier modif = Modifier.NewInstance();
-								String idmod = elModifier.getAttributeValue("id");
-								importRepresentation(elModifier, sddNamespace, modif, idmod, cdmState);
-								termVocabularyState.addTerm(modif);
-								//termVocabularyStates.add(termVocabularyState);
-								getVocabularyService().save(termVocabularyState);//XIM
-								modifiers.put(idmod, modif);
+							DefinedTerm modif = DefinedTerm.NewModifierInstance(null, null, null);
+							String idmod = elModifier.getAttributeValue("id");
+							importRepresentation(elModifier, sddNamespace, modif, idmod, cdmState);
+							termVocabularyState.addTerm(modif);
+							//termVocabularyStates.add(termVocabularyState);
+							getVocabularyService().save(termVocabularyState);//XIM
+							modifiers.put(idmod, modif);
 						}
-							feature.addRecommendedModifierEnumeration(termVocabularyState);
-				}
+						feature.addRecommendedModifierEnumeration(termVocabularyState);
+					}
 
 					}
 				}
@@ -1885,7 +1869,7 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 						Classification classification =  Classification.NewInstance(label);
 						importRepresentation(elTaxonHierarchy, sddNamespace, classification, "", cdmState);
 					
-						Set<TaxonNode> root = classification.getChildNodes();
+						List<TaxonNode> root = classification.getChildNodes();
 						Element elNodes = elTaxonHierarchy.getChild("Nodes", sddNamespace); // There can be only one <Nodes> block for TaxonHierarchies
 						List<Element> listNodes = elNodes.getChildren("Node", sddNamespace);
 						
@@ -1902,12 +1886,14 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 									String refP = elParent.getAttributeValue("ref");
 									if (!refP.equals("")) {
 										TaxonNode parent = taxonNodes.get(refP);
-										TaxonNode child = parent.addChildTaxon(taxon, sec, "", Synonym.NewInstance(tnb, sec));
+										TaxonNode child = parent.addChildTaxon(taxon, sec, null);
+										child.setSynonymToBeUsed( Synonym.NewInstance(tnb, sec)); //TODO is this required??
 										taxonNodes.put(idN,child);
 									}
 								}
 								else {
-									TaxonNode tn = classification.addChildTaxon(taxon, sec, "", Synonym.NewInstance(tnb, sec)); // if no parent found or the reference is broken, add the node to the root of the tree
+									TaxonNode tn = classification.addChildTaxon(taxon, sec, null); // if no parent found or the reference is broken, add the node to the root of the tree
+									tn.setSynonymToBeUsed( Synonym.NewInstance(tnb, sec));  //TODO is this required??
 									taxonNodes.put(idN,tn);
 								}
 							}
@@ -1940,7 +1926,7 @@ public class SDDDataSetImport extends CdmImportBase<SDDImportConfigurator, SDDIm
 			for (Element elGeographicArea : listGeographicAreas){
 
 				String id = elGeographicArea.getAttributeValue("id");
-				NamedArea na = new NamedArea();
+				NamedArea na = NamedArea.NewInstance();
 				importRepresentation(elGeographicArea, sddNamespace, na, id, cdmState);
 				namedAreas.put(id,na);
 								}
